VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmAwg 
   Caption         =   "Form1"
   ClientHeight    =   5880
   ClientLeft      =   3735
   ClientTop       =   2655
   ClientWidth     =   7650
   LinkTopic       =   "Form1"
   ScaleHeight     =   5880
   ScaleWidth      =   7650
   StartUpPosition =   3  'Windows ̊l
   Begin VB.CheckBox chk16BitPattern 
      Caption         =   "16 bit pattern"
      Enabled         =   0   'False
      Height          =   375
      Left            =   240
      TabIndex        =   12
      Top             =   3840
      Width           =   1575
   End
   Begin VB.CommandButton Busy 
      Caption         =   "BUSY"
      Height          =   255
      Left            =   6720
      TabIndex        =   10
      Top             =   5400
      Width           =   735
   End
   Begin VB.TextBox GpibAddress 
      Alignment       =   2  '
      Height          =   375
      Left            =   240
      TabIndex        =   8
      Text            =   "1"
      Top             =   1080
      Width           =   975
   End
   Begin VB.TextBox DestinationFile 
      Height          =   375
      Left            =   240
      TabIndex        =   6
      Top             =   2640
      Width           =   1815
   End
   Begin VB.CommandButton SendData 
      Caption         =   "Send Data"
      Height          =   495
      Left            =   240
      TabIndex        =   5
      Top             =   3120
      Width           =   1815
   End
   Begin VB.TextBox DataFileName 
      Height          =   375
      Left            =   2760
      TabIndex        =   3
      Top             =   1080
      Width           =   1815
   End
   Begin VB.TextBox ReadData 
      Height          =   4095
      Left            =   2760
      MultiLine       =   -1  'True
      ScrollBars      =   2  '
      TabIndex        =   2
      Top             =   1560
      Width           =   3855
   End
   Begin VB.CommandButton QuitApp 
      Caption         =   "Quit"
      Height          =   495
      Left            =   240
      TabIndex        =   1
      Top             =   5160
      Width           =   1815
   End
   Begin VB.CommandButton SelectDataFile 
      Caption         =   "Select Data File"
      Height          =   495
      Left            =   240
      MaskColor       =   &H000000FF&
      TabIndex        =   0
      Top             =   1680
      Width           =   1815
   End
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   6120
      Top             =   960
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      CancelError     =   -1  'True
      Filter          =   "Waveform (*.wfm)|*.wfm|Pattern (*.pat)|*.pat|Equation (*.equ)|*.equ|All (*.*)|*.*"
   End
   Begin VB.Label Label4 
      Caption         =   "AWG Sample Program (Data Sending)"
      BeginProperty Font 
         Name            =   "lr oSVbN"
         Size            =   14.25
         Charset         =   128
         Weight          =   700
         Underline       =   -1  'True
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   840
      TabIndex        =   11
      Top             =   240
      Width           =   6615
   End
   Begin VB.Label Label3 
      Caption         =   "Gpib Address"
      Height          =   255
      Left            =   240
      TabIndex        =   9
      Top             =   840
      Width           =   1695
   End
   Begin VB.Label Label2 
      Caption         =   "Destination File Name"
      Height          =   255
      Left            =   240
      TabIndex        =   7
      Top             =   2400
      Width           =   2295
   End
   Begin VB.Label Label1 
      Caption         =   "Data File Name"
      Height          =   255
      Left            =   2760
      TabIndex        =   4
      Top             =   840
      Width           =   1935
   End
End
Attribute VB_Name = "frmAwg"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Const MaxLineCount = 255
Const WfmFile = 0
Const PatFile = 1
Const EquFile = 2
Const UnknownFile = 3
Const MSIS_MAIN = 0
Const MSIS_FLOPPY = 1
Const MSIS_NET1 = 2
Const MSIS_NET2 = 3
Const MSIS_NET3 = 4

Dim Fname As String
Dim Ftitle As String
Dim DataType As Integer
Dim FileNum As Integer
Dim RdBuffer As String
Dim DestFilePath As String
Dim DestFileName As String

Dim Clock As Single
Dim DataPoint As Long

Private Declare Sub float2int Lib "dll4awg.dll" (ByVal fl As Single, ByRef byt As Byte)

Private Function DefineDataType(Name As String) As Integer
    Dim UName As String
    
    UName = UCase(Name)
    If InStr(UName, ".WFM") Then
        DefineDataType = WfmFile            'waveform data file
    ElseIf InStr(UName, ".PAT") Then
        DefineDataType = PatFile            'pattern data file
    ElseIf InStr(UName, ".EQU") Then
        DefineDataType = EquFile            'equation data file
    Else
        DefineDataType = UnknownFile            'unknown data file
    End If
End Function

Private Sub MakeFilePathName(PathName As String)
    Dim pos As Integer
    Dim prePos As Integer
    
    pos = InStr(PathName, "/")
    If pos = 0 Then
        DestFilePath = "./"
        DestFileName = PathName
    Else
        Do
            prePos = pos
            pos = InStr(prePos + 1, PathName, "/")
        Loop While pos > 0
        DestFilePath = Mid(PathName, 1, prePos - 0)
        DestFileName = Mid(PathName, prePos + 1, Len(PathName) - prePos)
    
    End If
End Sub

Private Function ReadDataHeader(Fn As Integer) As Integer
    Dim TextLine As String
    Dim pos As Integer
    
    Line Input #Fn, TextLine
    pos = InStr(TextLine, "#CLOCK")     'read CLOCK setting
    If pos = 0 Then
        Clock = 0#
        ReadDataHeader = False
        Exit Function
    Else
        Clock = Val(Mid(TextLine, pos + Len("#CLOCK")))
    End If

    Line Input #Fn, TextLine
    pos = InStr(TextLine, "#SIZE")      'read data size
    If pos = 0 Then
        DataPoint = 0
        ReadDataHeader = False
        Exit Function
    Else
        DataPoint = Val(Mid(TextLine, pos + Len("#SIZE")))
    End If
    ReadDataHeader = True
End Function

Private Function SendWfmData(filename As String) As Integer
    Dim SdBuffer As String
    Dim TextLine As String
    Dim WfmData As Single
    Dim Marker1 As Integer
    Dim Marker2 As Integer
    Dim Fstr As String * 4
    Dim i As Long
    Dim iwork As Integer
    Dim swork As String
    Dim back As String
    Dim bWaveform() As Byte
    Dim DataLen As Integer
    Dim SendLen As Integer
    Dim DataLenStr As String
    Dim SendLenStr As String


    FileNum = FreeFile
    Open filename For Input Access Read As #FileNum
    
    If Not ReadDataHeader(FileNum) Then
        MsgBox "file " + filename + ": format error"
        SendWfmData = False
        Exit Function
    End If
    
    DataLen = 5 * DataPoint
    
    ReDim bWaveform(DataLen)

    For i = 0 To DataPoint - 1
        
        If EOF(FileNum) Then
            MsgBox "file " + filename + ": premature EOF"
            SendWfmData = False
            Exit Function
        End If
        Line Input #FileNum, TextLine
        WfmData = Val(TextLine)
        Call float2int(WfmData, bWaveform(5 * i))
        
        iwork = InStr(TextLine, ",")
        swork = Mid(TextLine, iwork + 1)
        Marker1 = Val(swork)
        Marker2 = Val(Mid(swork, InStr(swork, ",") + 1))
        bWaveform(5 * i + 4) = (Marker1 + Marker2 * 2)
        
    Next i
    Close #FileNum
    
    swork = CStr(DataLen)
    DataLenStr = "#" + CStr(Len(swork)) + swork
    
    SendLen = 12 + Len(DataLenStr) + DataLen + 25
        '"MAGIC..." + "#..." + "WfmData" + "CLOCK..."
    swork = CStr(SendLen)
    SendLenStr = "#" + CStr(Len(swork)) + swork
    
    SdBuffer = "MMEMORY:DATA """ + DestFileName + """," + SendLenStr + _
                "MAGIC 1000" + Chr(13) + Chr(10) + DataLenStr
    
    Call GpibControlEOI(Device, 0)
    back = GpibWrt(Device, SdBuffer)
    
    Call GpibWriteByte(Device, bWaveform, DataLen)
    
    SdBuffer = "CLOCK " + MakeExpStr(Clock) + Chr(13) + Chr(10)
    Call GpibControlEOI(Device, 1)
    back = GpibWrt(Device, SdBuffer)
    
    SendWfmData = True
    
End Function

Private Function SendPatData(filename As String) As Integer
    Dim SdBuffer As String
    Dim TextLine As String
    Dim PatData As Integer
    Dim Marker1 As Integer
    Dim Marker2 As Integer
    Dim i As Long
    Dim iwork As Integer
    Dim swork As String
    Dim back As String
    Dim iPattern As Integer
    Dim bPattern() As Byte
    Dim DataLen As Integer
    Dim SendLen As Integer
    Dim DataLenStr As String
    Dim SendLenStr As String
    
    FileNum = FreeFile
    Open filename For Input Access Read As #FileNum
    
    If Not ReadDataHeader(FileNum) Then
        MsgBox "file " + filename + ": format error"
        SendPatData = False
        Exit Function
    End If
    
    DataLen = 2 * DataPoint
    
    ReDim bPattern(DataLen)
    
    For i = 0 To DataPoint - 1
        If EOF(FileNum) Then
            MsgBox "file " + filename + ": premature EOF"
            SendPatData = False
            Exit Function
        End If
        Line Input #FileNum, TextLine
        PatData = Val("&H" + TextLine)
        iwork = InStr(TextLine, ",")
        swork = Mid(TextLine, iwork + 1)
        Marker1 = Val(swork)
        Marker2 = Val(Mid(swork, InStr(swork, ",") + 1))
        iPattern = (PatData And &H3FF) Or (Marker1 * &H2000) Or (Marker2 * &H4000)
        bPattern(2 * i) = CByte(iPattern And &HFF)
        bPattern(2 * i + 1) = CByte(((iPattern And &HFF00) / &H100) And &HFF)

    Next i
    Close #FileNum
        
    swork = CStr(DataLen)
    DataLenStr = "#" + CStr(Len(swork)) + swork
    
    SendLen = 12 + Len(DataLenStr) + DataLen + 25
        '"MAGIC..." + "#..." + "patData" + "CLOCK..."
    swork = CStr(SendLen)
    SendLenStr = "#" + CStr(Len(swork)) + swork
    
    SdBuffer = "MMEMORY:DATA """ + DestFileName + """," + SendLenStr + _
                "MAGIC 2000" + Chr(13) + Chr(10) + DataLenStr
    Call GpibControlEOI(Device, 0)
    back = GpibWrt(Device, SdBuffer)
    
    'Debug.Print MakeHexDump(SdBuffer)

    Call GpibWriteByte(Device, bPattern, DataLen)
    
    SdBuffer = "CLOCK " + MakeExpStr(Clock) + Chr(13) + Chr(10)
    Call GpibControlEOI(Device, 1)
    back = GpibWrt(Device, SdBuffer)
    
    'Debug.Print MakeHexDump(SdBuffer)

    SendPatData = True
End Function

Private Function SendPat16Data(filename As String) As Integer
    Dim SdBuffer As String
    Dim TextLine As String
    Dim PatData As Integer
    Dim Marker1 As Integer
    Dim Marker2 As Integer
    Dim i As Long
    Dim iwork As Integer
    Dim swork As String
    Dim back As String
    Dim iPattern As Integer
    Dim bPattern() As Byte
    Dim DataLen As Integer
    Dim SendLen As Integer
    Dim DataLenStr As String
    Dim SendLenStr As String
    
    FileNum = FreeFile
    Open filename For Input Access Read As #FileNum
    
    If Not ReadDataHeader(FileNum) Then
        MsgBox "file " + filename + ": format error"
        SendPat16Data = False
        Exit Function
    End If
    
    DataLen = 3 * DataPoint
    
    ReDim bPattern(DataLen)
    
    For i = 0 To DataPoint - 1
        If EOF(FileNum) Then
            MsgBox "file " + filename + ": premature EOF"
            SendPat16Data = False
            Exit Function
        End If
        Line Input #FileNum, TextLine
        PatData = Val("&H" + TextLine)
        iwork = InStr(TextLine, ",")
        swork = Mid(TextLine, iwork + 1)
        Marker1 = Val(swork)
        Marker2 = Val(Mid(swork, InStr(swork, ",") + 1))
        iPattern = (PatData And &H3FF) Or (Marker1 * &H2000) Or (Marker2 * &H4000)
        bPattern(3 * i) = CByte(PatData And &HFF)
        bPattern(3 * i + 1) = CByte(((PatData And &HFF00) / &H100) And &HFF)
        bPattern(3 * i + 2) = CByte(Marker2 * 2 + Marker1)

    Next i
    Close #FileNum
        
    swork = CStr(DataLen)
    DataLenStr = "#" + CStr(Len(swork)) + swork
    
    SendLen = 12 + Len(DataLenStr) + DataLen + 25
        '"MAGIC..." + "#..." + "patData" + "CLOCK..."
    swork = CStr(SendLen)
    SendLenStr = "#" + CStr(Len(swork)) + swork
    
    SdBuffer = "MMEMORY:DATA """ + DestFileName + """," + SendLenStr + _
                "MAGIC 2003" + Chr(13) + Chr(10) + DataLenStr
    Call GpibControlEOI(Device, 0)
    back = GpibWrt(Device, SdBuffer)
    
    'Debug.Print MakeHexDump(SdBuffer)

    Call GpibWriteByte(Device, bPattern, DataLen)
    
    SdBuffer = "CLOCK " + MakeExpStr(Clock) + Chr(13) + Chr(10)
    Call GpibControlEOI(Device, 1)
    back = GpibWrt(Device, SdBuffer)
    
    'Debug.Print MakeHexDump(SdBuffer)

    SendPat16Data = True
End Function

Private Function SendEquData(filename As String) As Integer
    Dim SdBuffer As String
    Dim TextLine As String
    Dim lenStr As String
    Dim back As String

    FileNum = FreeFile
    Open filename For Input Access Read As #FileNum
    SdBuffer = ""
    Do While Not EOF(FileNum)
        Line Input #FileNum, TextLine
        SdBuffer = SdBuffer + TextLine + Chr(13) + Chr(10)
    Loop
    'Debug.Print LOF(FileNum), Len(SdBuffer)
    Close #FileNum
    
    lenStr = CStr(Len(SdBuffer))
    SdBuffer = "MMEMORY:DATA """ + DestFileName + """,#" + CStr(Len(lenStr)) + lenStr + SdBuffer
    'Debug.Print SdBuffer
    
    back = GpibWrt(Device, SdBuffer)
    SendEquData = True

End Function

Private Function SendMSIS(Storage As Integer) As String
    Dim SdBuffer As String
    Dim StorageName As String
    Dim back As String

    Select Case Storege
    Case MSIS_MAIN
        StorageName = "MAIN"
    Case MSIS_FLOPPY
        StorageName = "FLOPPY"
    Case MSIS_NET1
        StorageName = "NET1"
    Case MSIS_NET2
        StorageName = "NET2"
    Case MSIS_NET3
        StorageName = "NET3"
    Case Else
        StorageName = "MAIN"
    End Select
    SdBuffer = "MMEMORY:MSIS """ + StorageName + """"
    
    back = GpibWrt(Device, SdBuffer)

End Function

Private Function SendCDir(Dir As String) As Integer
    Dim SdBuffer As String
    Dim back As String

    SdBuffer = "MMEMORY:CDIRECTORY """ + Dir + """"
    
    back = GpibWrt(Device, SdBuffer)

End Function


Private Sub Form_Load()
    ' to call dll4awg.dll correctly
    ChDrive Left$(App.Path, 2)
    ChDir App.Path
    
    GpibAddress.Text = 1
    CommonDialog1.filename = "*.wfm"
    CommonDialog1.Filter = "Waveform (*.wfm)|*.wfm|Pattern (*.pat)|*.pat|Equation (*.equ)|*.equ|All (*.*)|*.*"
    ReadData.Text = ""
    DataFileName.Text = ""
    DestinationFile.Text = ""
    Busy.Visible = False
End Sub

Private Sub GpibAddress_Change()
    Dim InputVal As Integer
    Dim length As Integer
    Dim i As Integer
    Dim CheckedText As String
    Dim tmp As String
    
    length = Len(GpibAddress.Text)
    'If length = 0 Then
    '    GpibAddress.Text = "1"
    '    Exit Sub
    'End If
    
    CheckedText = ""
    For i = 1 To length
        tmp = Mid(GpibAddress.Text, i, 1)
        If Asc(tmp) >= Asc("0") And Asc(tmp) <= Asc("9") Then
            CheckedText = CheckedText + tmp
        End If
    Next i
    'If Len(CheckedText) = 0 Then
    '    GpibAddress.Text = "1"
    '    Exit Sub
    'End If
    GpibAddress.Text = CheckedText

    InputVal = Val(GpibAddress.Text)
    If InputVal < 1 Then
        GpibAddress.Text = "1"
        'MsgBox "BPIB Adress: 1 - 30"
    ElseIf InputVal > 30 Then
        GpibAddress.Text = "30"
        'MsgBox "BPIB Adress: 1 - 30"
    End If
    
End Sub

Private Sub SelectDataFile_Click()
    Dim stat As Integer
    Dim i As Integer
    Dim tmp As String
    
    Busy.Visible = True
    Busy.Refresh
    
    Fname = ""
    Ftitle = ""
    DataFileName.Text = ""
    RdBuffer = ""
    ReadData.Text = ""
    DestinationFile.Text = ""

    On Error Resume Next
    CommonDialog1.ShowOpen
    
    ' to call dll4awg.dll correctly
    ChDrive Left$(App.Path, 2)
    ChDir App.Path
        
    If err <> 0 Then
        On Error GoTo 0
        Exit Sub
    End If
    On Error GoTo 0

    Fname = CommonDialog1.filename
    Ftitle = CommonDialog1.FileTitle
    
    DataFileName.Text = Ftitle
    DataType = DefineDataType(Ftitle)
    
    chk16BitPattern.Enabled = (DataType = PatFile)
    
    Select Case DataType
    Case WfmFile
            tmp = "Waveform Data File" + Chr(13) + Chr(10) _
                + " Data Format is:" + Chr(13) + Chr(10) _
                + "  #CLOCK x" + Chr(13) + Chr(10) _
                + "  #SIZE n" + Chr(13) + Chr(10) _
                + "  waveform_(1),marker1_(1),marker2_(1)" + Chr(13) + Chr(10) _
                + "  waveform_(2),marker1_(2),marker2_(2)" + Chr(13) + Chr(10) _
                + "      .            .       ." + Chr(13) + Chr(10) _
                + "      .            .       ." + Chr(13) + Chr(10) _
                + "  waveform_(n),marker1_(n),marker2_(n)" + Chr(13) + Chr(10) _
                + Chr(13) + Chr(10) _
                + "  x        : Clock setting" + Chr(13) + Chr(10) _
                + "  n        : number of waveform data point" + Chr(13) + Chr(10) _
                + "  waveform : floating-point, -1.0 - 1.0" + Chr(13) + Chr(10) _
                + "  marker1  : marker1 data" + Chr(13) + Chr(10) _
                + "  marker2  : marker2 data" + Chr(13) + Chr(10) _
                + Chr(13) + Chr(10)
    Case PatFile
            tmp = "Pattern Data File" + Chr(13) + Chr(10) _
                + " Data Format is:" + Chr(13) + Chr(10) _
                + "  #CLOCK x" + Chr(13) + Chr(10) _
                + "  #SIZE n" + Chr(13) + Chr(10) _
                + "  pattern_(1),marker1_(1),marker2_(1)" + Chr(13) + Chr(10) _
                + "  pattern_(2),marker1_(2),marker2_(2)" + Chr(13) + Chr(10) _
                + "      .            .       ." + Chr(13) + Chr(10) _
                + "      .            .       ." + Chr(13) + Chr(10) _
                + "  pattern_(n),marker1_(n),marker2_(n)" + Chr(13) + Chr(10) _
                + Chr(13) + Chr(10) _
                + "  x       : Clock setting" + Chr(13) + Chr(10) _
                + "  n       : number of pattern data point" + Chr(13) + Chr(10) _
                + "  pattern : pattern data (hex)" + Chr(13) + Chr(10) _
                + "  marker1 : marker1 data" + Chr(13) + Chr(10) _
                + "  marker2 : marker2 data" + Chr(13) + Chr(10) _
                + Chr(13) + Chr(10)
    Case EquFile
            tmp = "Equation Data File" + Chr(13) + Chr(10) _
                + " Send all data to AWG with no conversion" + Chr(13) + Chr(10) _
                + Chr(13) + Chr(10)
    Case Else
            tmp = "Unknown format File" + Chr(13) + Chr(10) _
                + " Send all data to AWG with no conversion" + Chr(13) + Chr(10) _
                + Chr(13) + Chr(10)
    End Select

    FileNum = FreeFile
    Open Fname For Input Access Read As #FileNum
    'tmp = ""
    Do While Not EOF(FileNum)
        Line Input #FileNum, TextLine
        tmp = tmp + TextLine + Chr(13) + Chr(10)
    Loop
    Close #FileNum
    ReadData.Text = tmp
    tmp = ""
    
    Busy.Visible = False
    Busy.Refresh
    
End Sub

Private Sub SendData_Click()

    If ReadData.Text = "" Then
        MsgBox "Read data is empty."
        Exit Sub
    End If
    
    Busy.Visible = True
    Busy.Refresh

    If DestinationFile.Text = "" Then
        DestinationFile.Text = DataFileName.Text
    End If
    
    MakeFilePathName (DestinationFile.Text)
    
    GpibAddress = Val(GpibAddress.Text)
    Device = OpenDevice(GpibAddress)
    If Device > 0 Then
        SendMSIS (MSIS_MAIN)
        SendCDir (DestFilePath)
    
        Select Case DataType
        Case WfmFile
            SendWfmData (Fname)
        Case PatFile
            If chk16BitPattern = vbChecked Then
                SendPat16Data (Fname)
            Else
                SendPatData (Fname)
            End If
        Case EquFile
            SendEquData (Fname)
        Case Else
            SendEquData (Fname)
        End Select
        
        GpibCheckError (Device)
    End If
    
    Busy.Visible = False
    Busy.Refresh

End Sub

Private Sub QuitApp_Click()        'quit application
    End
End Sub

