VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form Form1 
   Caption         =   "Sample: AWG Remote Control by Network"
   ClientHeight    =   4455
   ClientLeft      =   45
   ClientTop       =   270
   ClientWidth     =   5295
   LinkTopic       =   "Form1"
   ScaleHeight     =   4455
   ScaleWidth      =   5295
   StartUpPosition =   3  'Windows ̊l
   Begin VB.CommandButton cmdCreate 
      Caption         =   "Create &WFM in AWG"
      Height          =   372
      Left            =   120
      TabIndex        =   13
      Top             =   3960
      Width           =   2052
   End
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   4320
      Top             =   3000
      _ExtentX        =   688
      _ExtentY        =   688
      _Version        =   393216
   End
   Begin VB.CommandButton cmdBrowse 
      Caption         =   "&Browse..."
      Height          =   372
      Left            =   4080
      TabIndex        =   8
      Top             =   2160
      Width           =   1092
   End
   Begin VB.CommandButton cmdUpload 
      Caption         =   "&Upload"
      Height          =   372
      Left            =   3000
      TabIndex        =   10
      Top             =   2760
      Width           =   1092
   End
   Begin VB.CommandButton cmdDownload 
      Caption         =   "&Download"
      Height          =   372
      Left            =   600
      TabIndex        =   9
      Top             =   2760
      Width           =   1092
   End
   Begin VB.TextBox txtLocalFile 
      Height          =   264
      Left            =   120
      TabIndex        =   7
      Top             =   2160
      Width           =   3852
   End
   Begin VB.TextBox txtRemoteFile 
      Height          =   264
      Left            =   120
      TabIndex        =   12
      Top             =   3600
      Width           =   3852
   End
   Begin VB.CommandButton cmdReceive 
      Caption         =   "&Receive"
      Height          =   372
      Left            =   4080
      TabIndex        =   5
      Top             =   1200
      Width           =   1092
   End
   Begin VB.TextBox txtResponse 
      Height          =   264
      Left            =   120
      TabIndex        =   4
      Top             =   1188
      Width           =   3852
   End
   Begin VB.TextBox txtCommand 
      Height          =   264
      Left            =   120
      TabIndex        =   1
      Top             =   468
      Width           =   3852
   End
   Begin VB.CommandButton cmdSend 
      Caption         =   "&Send"
      Height          =   372
      Left            =   4080
      TabIndex        =   2
      Top             =   480
      Width           =   1092
   End
   Begin VB.Line Line6 
      X1              =   2640
      X2              =   2520
      Y1              =   2640
      Y2              =   2760
   End
   Begin VB.Line Line5 
      X1              =   2760
      X2              =   2640
      Y1              =   2760
      Y2              =   2640
   End
   Begin VB.Line Line4 
      X1              =   2640
      X2              =   2640
      Y1              =   2640
      Y2              =   3240
   End
   Begin VB.Line Line3 
      X1              =   1920
      X2              =   1800
      Y1              =   3240
      Y2              =   3120
   End
   Begin VB.Line Line2 
      X1              =   1920
      X2              =   2040
      Y1              =   3240
      Y2              =   3120
   End
   Begin VB.Line Line1 
      X1              =   1920
      X2              =   1920
      Y1              =   2640
      Y2              =   3240
   End
   Begin VB.Label Label4 
      AutoSize        =   -1  'True
      Caption         =   "&Local (PC) File"
      Height          =   180
      Left            =   120
      TabIndex        =   6
      Top             =   1920
      Width           =   1140
   End
   Begin VB.Label Label3 
      AutoSize        =   -1  'True
      Caption         =   "Remote (&AWG) File"
      Height          =   180
      Left            =   120
      TabIndex        =   11
      Top             =   3360
      Width           =   1464
   End
   Begin VB.Label Label2 
      AutoSize        =   -1  'True
      Caption         =   "R&esponse"
      Height          =   180
      Left            =   120
      TabIndex        =   3
      Top             =   960
      Width           =   744
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "&Command"
      Height          =   180
      Left            =   120
      TabIndex        =   0
      Top             =   240
      Width           =   744
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'sample application to control AWG by the network
'
' This program calls awgLib.dll. It have to be in the same
' directory as this file.

Option Explicit

Private Declare Function AwgConnect& Lib "awgLib" (ByVal hostname$)
Private Declare Sub AwgDisconnect Lib "awgLib" (ByVal fd&)
Private Declare Function AwgSend& Lib "awgLib" (ByVal fd&, ByVal s$, ByVal length&)
Private Declare Function AwgSendBinary& Lib "awgLib" Alias "AwgSend" (ByVal fd&, bufAddr As Any, ByVal length&)
Private Declare Function AwgSendString& Lib "awgLib" (ByVal fd&, ByVal s$)
Private Declare Function AwgReceive& Lib "awgLib" (ByVal fd&, ByVal buf$, ByVal BUFSIZE&)
Private Declare Function AwgReceiveMessage& Lib "awgLib" (ByVal fd&, ByVal buf$, ByVal BUFSIZE&)
Private Declare Function AwgReceiveBinary& Lib "awgLib" (ByVal fd&, bufAddr As Any, ByVal BUFSIZE&)
Private Declare Function AwgSendFile& Lib "awgLib" (ByVal fd&, ByVal localFilename$, ByVal remoteFilename$)
Private Declare Function AwgReceiveFile& Lib "awgLib" (ByVal fd&, ByVal remoteFilename$, ByVal localFilename$)

Const BUFSIZE = 256

Private Type Waveform
    data As Single
    marker As Byte
End Type

Dim fd&

Public Function arbHeader(ByVal size&)
    Dim sizeStr$
    sizeStr = CStr(size)
    arbHeader = "#" & CStr(Len(sizeStr)) & sizeStr
End Function

Public Sub sendWaveform(ByVal dstFile$)
    Dim numPoints&, numBytes&, fileHeader$
    Dim fileSize&, cmd$
    Dim ret&, i&, d As Waveform
    
    numPoints = 1000
        
    numBytes = numPoints * 5
    fileHeader = "MAGIC 1000" & vbCrLf & arbHeader(numBytes)
    fileSize = Len(fileHeader) + numBytes
    cmd = "MMEM:DATA """ & dstFile & """," & arbHeader(fileSize) & fileHeader
    ret = AwgSendString(fd, cmd)
    If ret <> 0 Then
        MsgBox "AwgSendString failed"
        Exit Sub
    End If
    
    For i = 0 To numPoints - 1
        d.data = Sin(6.283185 * i / numPoints)
        If i And 1 Then
            d.marker = 1
        Else
            d.marker = 0
        End If
        ret = AwgSendBinary(fd, d, 5)
        If ret <> 0 Then
            MsgBox "AwgSendBinary failed"
            Exit Sub
        End If
    Next
    
    ret = AwgSendString(fd, vbLf)
    If ret <> 0 Then
        MsgBox "AwgSendString failed"
        Exit Sub
    End If
End Sub

Private Sub cmdBrowse_Click()
    CommonDialog1.ShowOpen
    
    ' to call awgLib.dll correctly
    ChDrive Left$(App.Path, 2)
    ChDir App.Path
    
    If CommonDialog1.FileName <> "" Then
        txtLocalFile = CommonDialog1.FileName
    End If
End Sub

Private Sub cmdCreate_Click()
    If txtRemoteFile = "" Then
        MsgBox "Remote File not specified."
        Exit Sub
    End If
    
    sendWaveform txtRemoteFile
End Sub

Private Sub cmdDownload_Click()
    If txtLocalFile = "" Then
        MsgBox "Local File not specified."
        Exit Sub
    End If
    If txtRemoteFile = "" Then
        MsgBox "Remote File not specified."
        Exit Sub
    End If
    
    Dim ret&
    ret = AwgSendFile(fd, txtLocalFile, txtRemoteFile)
    If ret <> 0 Then MsgBox "AwgSendFile failed"
End Sub

Private Sub cmdReceive_Click()
    Dim ret&, buf As String * BUFSIZE
    
    ret = AwgReceiveMessage(fd, buf, BUFSIZE - 1)
    If ret <= 0 Then
        MsgBox "AwgReceiveMessage failed"
        Exit Sub
    End If
    txtResponse.Text = Left$(buf, ret)
End Sub

Private Sub cmdSend_Click()
    Dim ret&
    ret = AwgSendString(fd, txtCommand.Text & vbLf)
    If ret <> 0 Then MsgBox "AwgSendString failed"
End Sub


Private Sub cmdUpload_Click()
    If txtLocalFile = "" Then
        MsgBox "Local File not specified."
        Exit Sub
    End If
    If txtRemoteFile = "" Then
        MsgBox "Remote File not specified."
        Exit Sub
    End If
    
    Dim ret&
    ret = AwgReceiveFile(fd, txtRemoteFile, txtLocalFile)
    If ret <> 0 Then MsgBox "AwgReceiveFile failed"
End Sub

Private Sub Form_Load()
    ' to call awgLib.dll correctly
    ChDrive Left$(App.Path, 2)
    ChDir App.Path
    
    Dim hostname$
    hostname = InputBox("Input hostname or IP-address")
    If hostname = "" Then End
    fd = AwgConnect(hostname)
    If fd <= 0 Then
        MsgBox "AwgConnect failed"
        End
    End If

End Sub

Private Sub Form_Unload(Cancel As Integer)
    AwgDisconnect fd
End Sub


Private Sub txtCommand_KeyDown(KeyCode As Integer, Shift As Integer)
    If KeyCode = 13 Then cmdSend_Click
End Sub

